/***************************************************************************
 $RCSfile: wizard.h,v $
 -------------------
 cvs         : $Id: wizard.h,v 1.4 2005/12/01 10:08:02 cstim Exp $
 begin       : Mon Mar 01 2004
 copyright   : (C) 2004 by Martin Preuss
 email       : martin@libchipcard.de

 ***************************************************************************
 *          Please see toplevel file COPYING for license details           *
 ***************************************************************************/


#ifndef AQHBCI_WIZARD_H
#define AQHBCI_WIZARD_H

class QBanking;
class Wizard;
class WizardAction;
class WizardInfo;

#include "wizard.ui.h"
#include "waction.h"
#include "winfo.h"

#include <qstring.h>
#include <qwizard.h>
#include <aqbanking/banking.h>

#include <list>


class Wizard: protected WizardUi {
  Q_OBJECT
private:
  QBanking *_app;
  WizardInfo *_wInfo;
  QWidget *_lastActionWidget;
  QString _logtext;

public:
  Wizard(QBanking *qb,
         WizardInfo *wInfo,
         const QString &caption=QString::null,
         QWidget* parent=0, const char* name=0,
         bool modal=FALSE);
  virtual ~Wizard();

  QBanking *getBanking();

  void addAction(WizardAction *a);
  WizardInfo *getWizardInfo();

  void log(AB_BANKING_LOGLEVEL level, const QString &s);
  void setDescription(const QString &s);

  QWidget *getWidgetAsParent();

  virtual int exec();

protected slots:
  virtual void back();
  virtual void next();
};



#endif

